VMware: Exception listing VMs in the root of the datacenter

03/06/2018 04:28 PM - Adam Grare

Status: Closed   

Priority: Normal   

Assignee:    

Category: Compute resources - VMware   

Target version: 1.18.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: Nightly

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5297

  

Description

When listing virtual machines under a compute_resource on VMware vSphere a folder hash is built of all folders under the

datacenter, but the datacenter's vmFolder is skipped in the PropertyFilterSpec.

This causes VMs which have the vmFolder as their parent to throw an undefined method '[]' for nil:NilClass error when they try to

access 'folder_inventory[vm['parent']._ref][:path]'.

Traceback:

2018-03-06T11:11:34 fd0ae69d [app] [W] Error has occurred while listing VMs on dev-vc65 (VMware)  | NoMethodError: undefined

method `[]' for nil:NilClass  | /home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:61:in

`lookup_parent_folders'  | /home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:62:in

`lookup_parent_folders'  | /home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:56:in `block in

set_folder_paths'  | /home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:55:in `each'  |

/home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:55:in `set_folder_paths'  |

/home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:50:in `generate_folder_inventory'  |

/home/agrare/src/foreman/app/services/fog_extensions/vsphere/mini_servers.rb:21:in `all'

Related issues:

Related to Foreman - Feature #22258: VMWare: Speed up VM listing Closed 01/12/2018

Associated revisions

Revision 68e96c10 - 03/13/2018 01:14 PM - Adam Grare

Fixes #22798 - VMware: Fix exception listing VMs

If a VM is in the root of the datacenter its parent is the vmFolder.

This folder was being skipped by the PropertyFilterSpec causing an

undefined method error '[]' for nil:NilClass when accessing the

vm['parent'] key.

History

#1 - 03/06/2018 04:31 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/5297 added

#2 - 03/11/2018 12:00 PM - Ohad Levy

- Category set to Compute resources - VMware

#3 - 03/13/2018 01:15 PM - Ohad Levy

- translation missing: en.field_release set to 330

#4 - 03/13/2018 01:16 PM - Ohad Levy

- Related to Feature #22258: VMWare: Speed up VM listing added
#5 - 03/14/2018 06:37 AM - Adam Grare

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 68e96c10b596d67106a3ed49535231019d8507b4.

Powered by TCPDF (www.tcpdf.org)

05/18/2024 2/2

https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/68e96c10b596d67106a3ed49535231019d8507b4
http://www.tcpdf.org

